#include <builtin.h>

void hdwinit(void);
void main(void);

int bssvar;
int __saddr sbssvar;

void hdwinit(void)
{
	/* 以下の(2)まで実行させてリスタートさせて(1)でブレークさせた時 */
	/* bssvar   ==> 0x0000 --> 正常 */
	/* sbssvar  ==> 0x0000 --> 正常 */

	__nop(); /* (1) for breakpoint */
	bssvar = 0xfedc;
	sbssvar = 0xba98;
	__nop(); /* (2) for breakpoint */

	/* もう用済みなので以後は期待値の0x0000にしておく */
	bssvar = 0x0000;
	sbssvar = 0x0000;
}

int datavar = 0x1234;
int __saddr sdatavar = 0x5678;

volatile const int mirrordata = 0x1357;
volatile int debugwatch;

void main(void)
{
	/* 以下の(3)でブレークさせた時 */
	/* datasvar ==> 0x1234 --> 正常 */
	/* sdatavar ==> 0x5648 --> 正常 */

	__nop(); /* (3) for breakpoint */

	/* 以下はアセンブラソースや逆アセンブルウィンドウでコードを確認する為 */

	debugwatch = mirrordata;

	while (1)
	{
		__nop();
	}
}
